//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 12.5 on page 229
//  Testing a PriorityQueue class

import java.util.*;

public class Ex1205
{ static public void main(String[] args)
  { PriorityQueue yobQueue = new PriorityQueue(new yobComparator());
    yobQueue.add(new Person("Barrow",1630));
    yobQueue.add(new Person("Fermat",1601));
    yobQueue.add(new Person("Pascal",1623));
    yobQueue.add(new Person("Wallis",1616));
    System.out.println(yobQueue);
  }
}

class Person
{ String name;
  int yob,yod;
  Person(String name, int yob)
  { this.name = name;
    this.yob = yob;
  }
  Person(String name, int yob, int yod)
  { this(name,yob);
    this.yod = yod;
  }
  public String toString()
  { return name + "(" + yob + (yod>0?"-"+yod:"") + ")";
  }
}
  
class yobComparator implements Comparator
{ public int compare(Object o1, Object o2)
  { if (o1==null || !(o1 instanceof Person)) return -1;
    Person p1 = (Person)o1;
    if (o2==null || !(o2 instanceof Person)) return  1;
    Person p2 = (Person)o2;
    if (p1.yob<p2.yob) return -1;
    if (p1.yob>p2.yob) return  1;
    return 0;
  }
}
