//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 12.7 on page 231
//  Testing a PriorityQueue class

import java.util.*;
import schaums.dswj.*;

public class Ex1207
{ static public void main(String[] args)
  { PriorityQueue yodQueue = new PriorityQueue(new YodComparator());
    yodQueue.add(new Person("Barrow",1630,1677));
    yodQueue.add(new Person("Fermat",1601,1665));
    yodQueue.add(new Person("Pascal",1623,1662));
    yodQueue.add(new Person("Wallis",1616,1703));
    System.out.println(yodQueue);
  }
}

class YodComparator implements java.util.Comparator
{ public int compare(Object o1, Object o2)
  { if (o1==null || !(o1 instanceof Person)) return -1;
    Person p1 = (Person)o1;
    if (o2==null || !(o2 instanceof Person)) return  1;
    Person p2 = (Person)o2;
    if (p1.yod<p2.yod) return -1;
    if (p1.yod>p2.yod) return  1;
    return 0;
  }
}
