//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2000
//  Problem 12.8 on page 
//  Using the PriorityQueue class in the client/server simulation

import schaums.dswj.*;

public class Pr1208
{ private static final int NUMBER_OF_SERVERS = 4;
  private static final double MEAN_INTERARRIVAL_TIME = 5.0;
  private static final int DURATION = 200;
  private static Server[] servers = new Server[NUMBER_OF_SERVERS];
  private static PriorityQueue clients = new PriorityQueue(new ClientComparator());
  private static Random random = new Random(MEAN_INTERARRIVAL_TIME);

  public static void main(String[] args)
  { for (int i=0; i<NUMBER_OF_SERVERS; i++)
      servers[i] = new Server();
    int timeOfNextArrival = random.intNextExponential();
    for (int t=0; t<DURATION; t++)
    { if (t == timeOfNextArrival)  // new arrival
      { clients.push(new Client(t));
        timeOfNextArrival += random.intNextExponential();
        System.out.println(t + "\t" + clients);
      }
      for (int i=0; i<NUMBER_OF_SERVERS; i++)  // process servers
        if (servers[i].isFree())
        { if(!clients.isEmpty())
            servers[i].beginServing((Client)clients.pop(),t);
        }
        else if (t == servers[i].getTimeServiceEnds())
          servers[i].endServing(t);
    }
  }
}
